Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Drawing

Imports PDFTRON
Imports PDFTRON.PDF
Imports PDFTRON.Filters


Namespace PDFViewVB
    Module Module1
        ' <summary>
        ' The main entry point for the application.
        ' </summary>
		<STAThread()> Sub Main()

			' Initialize PDFNet.
			Try
				PDFNet.Initialize()
			Catch ex As PDFTRON.Common.PDFNetException
				MessageBox.Show(ex.GetMessage(), "Licensing Error")
			End Try


			Try
				' Optional: Set ICC color profiles to fine tune color conversion 
				' for PDF 'device' color spaces. You can use your own ICC profiles. 
				' Standard Adobe color profiles can be download from Adobes site: 
				' http://www.adobe.com/support/downloads/iccprofiles/iccprofiles_win.html
				'
				' Simply drop all *.icc files in PDFNet resource folder or you specify 
				' the full pathname.
				'---
				' PDFNet.SetColorManagement()
				' PDFNet.SetDefaultDeviceCMYKProfile("USWebCoatedSWOP.icc") ' will search in PDFNet resource folder.
				' PDFNet.SetDefaultDeviceRGBProfile("AdobeRGB1998.icc")

				' Optional: Set predefined font mappings to override default font 
				' substitution for documents with missing fonts. For example:
				'---
				' PDFNet.AddFontSubst("StoneSans-Semibold", "C:/WINDOWS/Fonts/comic.ttf")
				' PDFNet.AddFontSubst("StoneSans", "comic.ttf");  ' search for 'comic.ttf' in PDFNet resource folder.
				' PDFNet.AddFontSubst(PDFNet.CharacterOrdering.e_Identity, "C:/WINDOWS/Fonts/arialuni.ttf")
				' PDFNet.AddFontSubst(PDFNet.CharacterOrdering.e_Japan1, "C:/Program Files/Adobe/Acrobat 7.0/Resource/CIDFont/KozMinProVI-Regular.otf")
				' PDFNet.AddFontSubst(PDFNet.CharacterOrdering.e_Japan2, "c:/myfonts/KozMinProVI-Regular.otf")
				'
				' If fonts are in PDFNet resource folder, it is not necessary to specify 
				' the full path name. For example,
				'---
				' PDFNet.AddFontSubst(PDFNet.CharacterOrdering.e_Korea1, "AdobeMyungjoStd-Medium.otf")
				' PDFNet.AddFontSubst(PDFNet.CharacterOrdering.e_CNS1, "AdobeSongStd-Light.otf")
				' PDFNet.AddFontSubst(PDFNet.CharacterOrdering.e_GB1, "AdobeMingStd-Light.otf")
			Catch generatedExceptionVariable0 As Exception
				MessageBox.Show("The specified color profile was not found.")
			End Try

			' Register the standard security handler (i.e. used to collect passwords). 
			Dim del As PDFTRON.SDF.CreateDelegate = New PDFTRON.SDF.CreateDelegate(AddressOf PDFViewSecurityHandler.Create)
			PDFTRON.SDF.SecurityManagerSingleton.Instance.RegisterSecurityHandler("Standard", New PDFTRON.SDF.SecurityDescriptor("Standard Security", del))
			Application.Run(New MainForm)
			PDFNet.Terminate()
		End Sub
	End Module
End Namespace

Public Class MainForm
    Inherits System.Windows.Forms.Form

    Public _current_page As Integer = 0
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents Pan As System.Windows.Forms.MenuItem
    Friend WithEvents StructuralTextSelection As System.Windows.Forms.MenuItem
    Friend WithEvents RectangularTextSelecction As System.Windows.Forms.MenuItem
    Friend WithEvents RectangleZoomIn As System.Windows.Forms.MenuItem
    Friend WithEvents RectangleZoomOut As System.Windows.Forms.MenuItem
    Friend WithEvents LinAnnotation As System.Windows.Forms.MenuItem
    Friend WithEvents RectangleAnnotation As System.Windows.Forms.MenuItem
    Friend WithEvents EllipseAnnotation As System.Windows.Forms.MenuItem
    Friend WithEvents FreehandAnnotation As System.Windows.Forms.MenuItem
    Friend WithEvents ArrowAnnotation As System.Windows.Forms.MenuItem
    Friend WithEvents AnnotaitonEdit As System.Windows.Forms.MenuItem
    Friend WithEvents CustomPDFDrawTool As System.Windows.Forms.MenuItem
    Friend WithEvents CustomLinkCreateTool As System.Windows.Forms.MenuItem
    Public _num_pages As Integer = 0


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()



        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents ToolBar1 As System.Windows.Forms.ToolBar
    Friend WithEvents ImageList1 As System.Windows.Forms.ImageList
    Friend WithEvents StatusBar As System.Windows.Forms.StatusBar
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem3 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem4 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem5 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem6 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem19 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem22 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem31 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem33 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem35 As System.Windows.Forms.MenuItem
    Friend WithEvents OpenFileDialog1 As System.Windows.Forms.OpenFileDialog
    Private WithEvents FileOpenButton As System.Windows.Forms.ToolBarButton
    Private WithEvents Separator1 As System.Windows.Forms.ToolBarButton
    Private WithEvents HandToolButton As System.Windows.Forms.ToolBarButton
    Private WithEvents PencilToolButton As System.Windows.Forms.ToolBarButton
    Private WithEvents LinkCreateToolButton As System.Windows.Forms.ToolBarButton
    Private WithEvents Separator2 As System.Windows.Forms.ToolBarButton
    Private WithEvents FitPageButton As System.Windows.Forms.ToolBarButton
    Private WithEvents FitWidthButton As System.Windows.Forms.ToolBarButton
    Private WithEvents Separator3 As System.Windows.Forms.ToolBarButton
    Private WithEvents ZoomInToolButton As System.Windows.Forms.ToolBarButton
    Private WithEvents ZoomOutToolButton As System.Windows.Forms.ToolBarButton
    Private WithEvents Separator4 As System.Windows.Forms.ToolBarButton
    Private WithEvents ZoomInButton As System.Windows.Forms.ToolBarButton
    Private WithEvents ZoomOutButton As System.Windows.Forms.ToolBarButton
    Friend WithEvents Separator5 As System.Windows.Forms.ToolBarButton
    Friend WithEvents FirstPageButton As System.Windows.Forms.ToolBarButton
    Friend WithEvents NextPageButton As System.Windows.Forms.ToolBarButton
    Friend WithEvents LastPageButton As System.Windows.Forms.ToolBarButton
    Friend WithEvents Separator6 As System.Windows.Forms.ToolBarButton
    Friend WithEvents PageSingleButton As System.Windows.Forms.ToolBarButton
    Friend WithEvents PageSingleContButton As System.Windows.Forms.ToolBarButton
    Friend WithEvents PageFacingContButton As System.Windows.Forms.ToolBarButton
    Friend WithEvents PageFacingButton As System.Windows.Forms.ToolBarButton
    Friend WithEvents Separator7 As System.Windows.Forms.ToolBarButton
    Friend WithEvents PrevPageButton As System.Windows.Forms.ToolBarButton
    Friend WithEvents RotateClockwise As System.Windows.Forms.ToolBarButton
    Friend WithEvents RotateCounterClockwise As System.Windows.Forms.ToolBarButton
    Friend WithEvents SaveAsButton As System.Windows.Forms.ToolBarButton
    Friend WithEvents PrintButton As System.Windows.Forms.ToolBarButton

    Friend WithEvents TextSelectButton As System.Windows.Forms.ToolBarButton
    Friend WithEvents RectTextSelectButton As System.Windows.Forms.ToolBarButton
    Friend WithEvents Separator8 As System.Windows.Forms.ToolBarButton

    Private smooth_images As Boolean = True
    Private anti_alias As Boolean = True
    Private builtin_rasterizer As Boolean = True
    Friend WithEvents MenuSmoothImages As System.Windows.Forms.MenuItem
    Friend WithEvents MenuAntiAlias As System.Windows.Forms.MenuItem
    Friend WithEvents MenuBuiltInRasterizer As System.Windows.Forms.MenuItem
    Friend WithEvents MenuPrint As System.Windows.Forms.MenuItem
    Friend WithEvents MenuFileOpen As System.Windows.Forms.MenuItem
    Friend WithEvents MenuFileClose As System.Windows.Forms.MenuItem
    Friend WithEvents MenuFileCloseAll As System.Windows.Forms.MenuItem
    Friend WithEvents MenuFileSaveAs As System.Windows.Forms.MenuItem
    Friend WithEvents MenuFileExport As System.Windows.Forms.MenuItem
    Friend WithEvents MenuExit As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemToolbar As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItemStatusBar As System.Windows.Forms.MenuItem
    Friend WithEvents MenuViewZoomIn As System.Windows.Forms.MenuItem
    Friend WithEvents MenuViewZoomOut As System.Windows.Forms.MenuItem
    Friend WithEvents MenuViewFirstPage As System.Windows.Forms.MenuItem
    Friend WithEvents MenuViewNextPage As System.Windows.Forms.MenuItem
    Friend WithEvents MenuViewLastPage As System.Windows.Forms.MenuItem
    Friend WithEvents MenuViewPreviousPage As System.Windows.Forms.MenuItem
    Friend WithEvents MenuViewAbout As System.Windows.Forms.MenuItem
    Friend WithEvents MenuWindowTileHorizontal As System.Windows.Forms.MenuItem
    Friend WithEvents MenuWindowTileVertical As System.Windows.Forms.MenuItem
    Friend WithEvents MenuWindowCascade As System.Windows.Forms.MenuItem
    Friend WithEvents MenuWindowCloseAll As System.Windows.Forms.MenuItem
    Friend WithEvents File As System.Windows.Forms.MainMenu
    Friend WithEvents MenuFileSave As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem11 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuEdit As System.Windows.Forms.MenuItem
    Friend WithEvents MenuCopyText As System.Windows.Forms.MenuItem
    Friend WithEvents MenuCopyTextAsHTML As System.Windows.Forms.MenuItem
    Friend WithEvents MenuSelectAll As System.Windows.Forms.MenuItem
    Friend WithEvents MenuDeselect As System.Windows.Forms.MenuItem
    Friend WithEvents MenuFindText As System.Windows.Forms.MenuItem

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(MainForm))
        Me.ToolBar1 = New System.Windows.Forms.ToolBar
        Me.FileOpenButton = New System.Windows.Forms.ToolBarButton
        Me.SaveAsButton = New System.Windows.Forms.ToolBarButton
        Me.PrintButton = New System.Windows.Forms.ToolBarButton
        Me.Separator1 = New System.Windows.Forms.ToolBarButton
        Me.HandToolButton = New System.Windows.Forms.ToolBarButton
        Me.RectTextSelectButton = New System.Windows.Forms.ToolBarButton
        Me.TextSelectButton = New System.Windows.Forms.ToolBarButton
        Me.Separator8 = New System.Windows.Forms.ToolBarButton
        Me.PencilToolButton = New System.Windows.Forms.ToolBarButton
        Me.LinkCreateToolButton = New System.Windows.Forms.ToolBarButton
        Me.Separator2 = New System.Windows.Forms.ToolBarButton
        Me.FitPageButton = New System.Windows.Forms.ToolBarButton
        Me.FitWidthButton = New System.Windows.Forms.ToolBarButton
        Me.Separator3 = New System.Windows.Forms.ToolBarButton
        Me.ZoomInToolButton = New System.Windows.Forms.ToolBarButton
        Me.ZoomOutToolButton = New System.Windows.Forms.ToolBarButton
        Me.Separator4 = New System.Windows.Forms.ToolBarButton
        Me.ZoomInButton = New System.Windows.Forms.ToolBarButton
        Me.ZoomOutButton = New System.Windows.Forms.ToolBarButton
        Me.Separator5 = New System.Windows.Forms.ToolBarButton
        Me.FirstPageButton = New System.Windows.Forms.ToolBarButton
        Me.PrevPageButton = New System.Windows.Forms.ToolBarButton
        Me.NextPageButton = New System.Windows.Forms.ToolBarButton
        Me.LastPageButton = New System.Windows.Forms.ToolBarButton
        Me.Separator6 = New System.Windows.Forms.ToolBarButton
        Me.PageSingleButton = New System.Windows.Forms.ToolBarButton
        Me.PageSingleContButton = New System.Windows.Forms.ToolBarButton
        Me.PageFacingContButton = New System.Windows.Forms.ToolBarButton
        Me.PageFacingButton = New System.Windows.Forms.ToolBarButton
        Me.Separator7 = New System.Windows.Forms.ToolBarButton
        Me.RotateClockwise = New System.Windows.Forms.ToolBarButton
        Me.RotateCounterClockwise = New System.Windows.Forms.ToolBarButton
        Me.ImageList1 = New System.Windows.Forms.ImageList(Me.components)
        Me.File = New System.Windows.Forms.MainMenu
        Me.MenuItem2 = New System.Windows.Forms.MenuItem
        Me.MenuFileOpen = New System.Windows.Forms.MenuItem
        Me.MenuFileClose = New System.Windows.Forms.MenuItem
        Me.MenuFileCloseAll = New System.Windows.Forms.MenuItem
        Me.MenuFileSave = New System.Windows.Forms.MenuItem
        Me.MenuFileSaveAs = New System.Windows.Forms.MenuItem
        Me.MenuItem31 = New System.Windows.Forms.MenuItem
        Me.MenuFileExport = New System.Windows.Forms.MenuItem
        Me.MenuItem33 = New System.Windows.Forms.MenuItem
        Me.MenuPrint = New System.Windows.Forms.MenuItem
        Me.MenuItem35 = New System.Windows.Forms.MenuItem
        Me.MenuExit = New System.Windows.Forms.MenuItem
        Me.MenuEdit = New System.Windows.Forms.MenuItem
        Me.MenuCopyText = New System.Windows.Forms.MenuItem
        Me.MenuCopyTextAsHTML = New System.Windows.Forms.MenuItem
        Me.MenuSelectAll = New System.Windows.Forms.MenuItem
        Me.MenuDeselect = New System.Windows.Forms.MenuItem
        Me.MenuItem11 = New System.Windows.Forms.MenuItem
        Me.MenuFindText = New System.Windows.Forms.MenuItem
        Me.MenuItem3 = New System.Windows.Forms.MenuItem
        Me.MenuItemToolbar = New System.Windows.Forms.MenuItem
        Me.MenuItemStatusBar = New System.Windows.Forms.MenuItem
        Me.MenuItem19 = New System.Windows.Forms.MenuItem
        Me.MenuViewZoomIn = New System.Windows.Forms.MenuItem
        Me.MenuViewZoomOut = New System.Windows.Forms.MenuItem
        Me.MenuItem22 = New System.Windows.Forms.MenuItem
        Me.MenuViewFirstPage = New System.Windows.Forms.MenuItem
        Me.MenuViewPreviousPage = New System.Windows.Forms.MenuItem
        Me.MenuViewNextPage = New System.Windows.Forms.MenuItem
        Me.MenuViewLastPage = New System.Windows.Forms.MenuItem
        Me.MenuItem4 = New System.Windows.Forms.MenuItem
        Me.MenuSmoothImages = New System.Windows.Forms.MenuItem
        Me.MenuAntiAlias = New System.Windows.Forms.MenuItem
        Me.MenuBuiltInRasterizer = New System.Windows.Forms.MenuItem
        Me.MenuItem5 = New System.Windows.Forms.MenuItem
        Me.MenuWindowTileHorizontal = New System.Windows.Forms.MenuItem
        Me.MenuWindowTileVertical = New System.Windows.Forms.MenuItem
        Me.MenuWindowCascade = New System.Windows.Forms.MenuItem
        Me.MenuWindowCloseAll = New System.Windows.Forms.MenuItem
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.Pan = New System.Windows.Forms.MenuItem
        Me.StructuralTextSelection = New System.Windows.Forms.MenuItem
        Me.RectangularTextSelecction = New System.Windows.Forms.MenuItem
        Me.RectangleZoomIn = New System.Windows.Forms.MenuItem
        Me.RectangleZoomOut = New System.Windows.Forms.MenuItem
        Me.LinAnnotation = New System.Windows.Forms.MenuItem
        Me.RectangleAnnotation = New System.Windows.Forms.MenuItem
        Me.EllipseAnnotation = New System.Windows.Forms.MenuItem
        Me.FreehandAnnotation = New System.Windows.Forms.MenuItem
        Me.ArrowAnnotation = New System.Windows.Forms.MenuItem
        Me.AnnotaitonEdit = New System.Windows.Forms.MenuItem
        Me.CustomPDFDrawTool = New System.Windows.Forms.MenuItem
        Me.CustomLinkCreateTool = New System.Windows.Forms.MenuItem
        Me.MenuItem6 = New System.Windows.Forms.MenuItem
        Me.MenuViewAbout = New System.Windows.Forms.MenuItem
        Me.StatusBar = New System.Windows.Forms.StatusBar
        Me.OpenFileDialog1 = New System.Windows.Forms.OpenFileDialog
        Me.SuspendLayout()
        '
        'ToolBar1
        '
        Me.ToolBar1.Appearance = System.Windows.Forms.ToolBarAppearance.Flat
        Me.ToolBar1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.ToolBar1.Buttons.AddRange(New System.Windows.Forms.ToolBarButton() {Me.FileOpenButton, Me.SaveAsButton, Me.PrintButton, Me.Separator1, Me.HandToolButton, Me.RectTextSelectButton, Me.TextSelectButton, Me.Separator8, Me.PencilToolButton, Me.LinkCreateToolButton, Me.Separator2, Me.FitPageButton, Me.FitWidthButton, Me.Separator3, Me.ZoomInToolButton, Me.ZoomOutToolButton, Me.Separator4, Me.ZoomInButton, Me.ZoomOutButton, Me.Separator5, Me.FirstPageButton, Me.PrevPageButton, Me.NextPageButton, Me.LastPageButton, Me.Separator6, Me.PageSingleButton, Me.PageSingleContButton, Me.PageFacingContButton, Me.PageFacingButton, Me.Separator7, Me.RotateClockwise, Me.RotateCounterClockwise})
        Me.ToolBar1.ButtonSize = New System.Drawing.Size(30, 25)
        Me.ToolBar1.DropDownArrows = True
        Me.ToolBar1.ImageList = Me.ImageList1
        Me.ToolBar1.Location = New System.Drawing.Point(0, 0)
        Me.ToolBar1.Name = "ToolBar1"
        Me.ToolBar1.ShowToolTips = True
        Me.ToolBar1.Size = New System.Drawing.Size(840, 33)
        Me.ToolBar1.TabIndex = 0
        '
        'FileOpenButton
        '
        Me.FileOpenButton.ImageIndex = 2
        ' Me.FileOpenButton.Name = "FileOpenButton"
        Me.FileOpenButton.ToolTipText = "Open"
        '
        'SaveAsButton
        '
        Me.SaveAsButton.ImageIndex = 15
        'Me.SaveAsButton.Name = "SaveAsButton"
        Me.SaveAsButton.ToolTipText = "Save"
        '
        'PrintButton
        '
        Me.PrintButton.ImageIndex = 12
        'Me.PrintButton.Name = "PrintButton"
        Me.PrintButton.ToolTipText = "Print"
        '
        'Separator1
        '
        'Me.Separator1.Name = "Separator1"
        Me.Separator1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
        '
        'HandToolButton
        '
        Me.HandToolButton.ImageIndex = 22
        ' Me.HandToolButton.Name = "HandToolButton"
        Me.HandToolButton.Pushed = True
        Me.HandToolButton.ToolTipText = "Hand Tool"
        '
        'RectTextSelectButton
        '
        Me.RectTextSelectButton.ImageIndex = 24
        ' Me.RectTextSelectButton.Name = "RectTextSelectButton"
        Me.RectTextSelectButton.ToolTipText = "Rectangular Text Select"
        '
        'TextSelectButton
        '
        Me.TextSelectButton.ImageIndex = 23
        'Me.TextSelectButton.Name = "TextSelectButton"
        Me.TextSelectButton.ToolTipText = "Structure Text Select"
        '
        'Separator8
        '
        'Me.Separator8.Name = "Separator8"
        Me.Separator8.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
        '
        'PencilToolButton
        '
        Me.PencilToolButton.ImageIndex = 10
        'Me.PencilToolButton.Name = "PencilToolButton"
        Me.PencilToolButton.ToolTipText = "Pencil Tool"
        '
        'LinkCreateToolButton
        '
        Me.LinkCreateToolButton.ImageIndex = 8
        ' Me.LinkCreateToolButton.Name = "LinkCreateToolButton"
        Me.LinkCreateToolButton.ToolTipText = "Create New Links"
        '
        'Separator2
        '
        'Me.Separator2.Name = "Separator2"
        Me.Separator2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
        '
        'FitPageButton
        '
        Me.FitPageButton.ImageIndex = 4
        'Me.FitPageButton.Name = "FitPageButton"
        Me.FitPageButton.ToolTipText = "Fit Page"
        '
        'FitWidthButton
        '
        Me.FitWidthButton.ImageIndex = 5
        ' Me.FitWidthButton.Name = "FitWidthButton"
        Me.FitWidthButton.ToolTipText = "Fit Page Width"
        '
        'Separator3
        '
        'Me.Separator3.Name = "Separator3"
        Me.Separator3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
        '
        'ZoomInToolButton
        '
        Me.ZoomInToolButton.ImageIndex = 19
        ' Me.ZoomInToolButton.Name = "ZoomInToolButton"
        Me.ZoomInToolButton.ToolTipText = "Zoom In Tool"
        '
        'ZoomOutToolButton
        '
        Me.ZoomOutToolButton.ImageIndex = 21
        ' Me.ZoomOutToolButton.Name = "ZoomOutToolButton"
        Me.ZoomOutToolButton.ToolTipText = "Zoom Out Tool"
        '
        'Separator4
        '
        'Me.Separator4.Name = "Separator4"
        Me.Separator4.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
        '
        'ZoomInButton
        '
        Me.ZoomInButton.ImageIndex = 20
        'Me.ZoomInButton.Name = "ZoomInButton"
        Me.ZoomInButton.ToolTipText = "Zoom In"
        '
        'ZoomOutButton
        '
        Me.ZoomOutButton.ImageIndex = 18
        ' Me.ZoomOutButton.Name = "ZoomOutButton"
        Me.ZoomOutButton.ToolTipText = "Zoom Out"
        '
        'Separator5
        '
        ' Me.Separator5.Name = "Separator5"
        Me.Separator5.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
        '
        'FirstPageButton
        '
        Me.FirstPageButton.ImageIndex = 3
        'Me.FirstPageButton.Name = "FirstPageButton"
        Me.FirstPageButton.ToolTipText = "First Page"
        '
        'PrevPageButton
        '
        Me.PrevPageButton.ImageIndex = 11
        'Me.PrevPageButton.Name = "PrevPageButton"
        Me.PrevPageButton.ToolTipText = "Previous Page"
        '
        'NextPageButton
        '
        Me.NextPageButton.ImageIndex = 9
        'Me.NextPageButton.Name = "NextPageButton"
        Me.NextPageButton.ToolTipText = "Next Page"
        '
        'LastPageButton
        '
        Me.LastPageButton.ImageIndex = 7
        ' Me.LastPageButton.Name = "LastPageButton"
        Me.LastPageButton.ToolTipText = "Last Page"
        '
        'Separator6
        '
        'Me.Separator6.Name = "Separator6"
        Me.Separator6.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
        '
        'PageSingleButton
        '
        Me.PageSingleButton.ImageIndex = 16
        ' Me.PageSingleButton.Name = "PageSingleButton"
        Me.PageSingleButton.ToolTipText = "Single Page"
        '
        'PageSingleContButton
        '
        Me.PageSingleContButton.ImageIndex = 17
        'Me.PageSingleContButton.Name = "PageSingleContButton"
        Me.PageSingleContButton.ToolTipText = "Single Continuous"
        '
        'PageFacingContButton
        '
        Me.PageFacingContButton.ImageIndex = 1
        'Me.PageFacingContButton.Name = "PageFacingContButton"
        Me.PageFacingContButton.ToolTipText = "Facing Continuous"
        '
        'PageFacingButton
        '
        Me.PageFacingButton.ImageIndex = 0
        'Me.PageFacingButton.Name = "PageFacingButton"
        Me.PageFacingButton.ToolTipText = "Facing Continuous"
        '
        'Separator7
        '
        'Me.Separator7.Name = "Separator7"
        Me.Separator7.Style = System.Windows.Forms.ToolBarButtonStyle.Separator
        '
        'RotateClockwise
        '
        Me.RotateClockwise.ImageIndex = 14
        'Me.RotateClockwise.Name = "RotateClockwise"
        Me.RotateClockwise.ToolTipText = "Rotate Clockwise"
        '
        'RotateCounterClockwise
        '
        Me.RotateCounterClockwise.ImageIndex = 13
        ' Me.RotateCounterClockwise.Name = "RotateCounterClockwise"
        Me.RotateCounterClockwise.ToolTipText = "Rotate Counterclockwise"
        '
        'ImageList1
        '
        Me.ImageList1.ImageStream = CType(resources.GetObject("ImageList1.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ImageList1.TransparentColor = System.Drawing.Color.White
        'Me.ImageList1.Images.SetKeyName(0, "")
        'Me.ImageList1.Images.SetKeyName(1, "")
        'Me.ImageList1.Images.SetKeyName(2, "")
        'Me.ImageList1.Images.SetKeyName(3, "")
        'Me.ImageList1.Images.SetKeyName(4, "")
        'Me.ImageList1.Images.SetKeyName(5, "")
        'Me.ImageList1.Images.SetKeyName(6, "")
        'Me.ImageList1.Images.SetKeyName(7, "")
        'Me.ImageList1.Images.SetKeyName(8, "")
        'Me.ImageList1.Images.SetKeyName(9, "")
        'Me.ImageList1.Images.SetKeyName(10, "")
        'Me.ImageList1.Images.SetKeyName(11, "")
        'Me.ImageList1.Images.SetKeyName(12, "")
        'Me.ImageList1.Images.SetKeyName(13, "")
        'Me.ImageList1.Images.SetKeyName(14, "")
        'Me.ImageList1.Images.SetKeyName(15, "")
        'Me.ImageList1.Images.SetKeyName(16, "")
        'Me.ImageList1.Images.SetKeyName(17, "")
        'Me.ImageList1.Images.SetKeyName(18, "")
        'Me.ImageList1.Images.SetKeyName(19, "")
        'Me.ImageList1.Images.SetKeyName(20, "")
        'Me.ImageList1.Images.SetKeyName(21, "")
        'Me.ImageList1.Images.SetKeyName(22, "")
        'Me.ImageList1.Images.SetKeyName(23, "")
        'Me.ImageList1.Images.SetKeyName(24, "")
        '
        ''File
        '
        Me.File.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem2, Me.MenuEdit, Me.MenuItem3, Me.MenuItem4, Me.MenuItem5, Me.MenuItem1, Me.MenuItem6})
        '
        'MenuItem2
        '
        Me.MenuItem2.Index = 0
        Me.MenuItem2.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuFileOpen, Me.MenuFileClose, Me.MenuFileCloseAll, Me.MenuFileSave, Me.MenuFileSaveAs, Me.MenuItem31, Me.MenuFileExport, Me.MenuItem33, Me.MenuPrint, Me.MenuItem35, Me.MenuExit})
        Me.MenuItem2.Text = "File"
        '
        'MenuFileOpen
        '
        Me.MenuFileOpen.Index = 0
        Me.MenuFileOpen.Text = "Open..."
        '
        'MenuFileClose
        '
        Me.MenuFileClose.Index = 1
        Me.MenuFileClose.Text = "Close"
        '
        'MenuFileCloseAll
        '
        Me.MenuFileCloseAll.Index = 2
        Me.MenuFileCloseAll.Text = "Close All"
        '
        'MenuFileSave
        '
        Me.MenuFileSave.Index = 3
        Me.MenuFileSave.Text = "Save"
        '
        'MenuFileSaveAs
        '
        Me.MenuFileSaveAs.Index = 4
        Me.MenuFileSaveAs.Text = "Save As..."
        '
        'MenuItem31
        '
        Me.MenuItem31.Index = 5
        Me.MenuItem31.Text = "-"
        '
        'MenuFileExport
        '
        Me.MenuFileExport.Index = 6
        Me.MenuFileExport.Text = "Export..."
        '
        'MenuItem33
        '
        Me.MenuItem33.Index = 7
        Me.MenuItem33.Text = "-"
        '
        'MenuPrint
        '
        Me.MenuPrint.Index = 8
        Me.MenuPrint.Text = "Print..."
        '
        'MenuItem35
        '
        Me.MenuItem35.Index = 9
        Me.MenuItem35.Text = "-"
        '
        'MenuExit
        '
        Me.MenuExit.Index = 10
        Me.MenuExit.Text = "Exit"
        '
        'MenuEdit
        '
        Me.MenuEdit.Index = 1
        Me.MenuEdit.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuCopyText, Me.MenuCopyTextAsHTML, Me.MenuSelectAll, Me.MenuDeselect, Me.MenuItem11, Me.MenuFindText})
        Me.MenuEdit.Text = "Edit"
        '
        'MenuCopyText
        '
        Me.MenuCopyText.Index = 0
        Me.MenuCopyText.Text = "Copy"
        '
        'MenuCopyTextAsHTML
        '
        Me.MenuCopyTextAsHTML.Index = 1
        Me.MenuCopyTextAsHTML.Text = "Copy as HTML"
        '
        'MenuSelectAll
        '
        Me.MenuSelectAll.Index = 2
        Me.MenuSelectAll.Text = "Select All"
        '
        'MenuDeselect
        '
        Me.MenuDeselect.Index = 3
        Me.MenuDeselect.Text = "Deselect All"
        '
        'MenuItem11
        '
        Me.MenuItem11.Index = 4
        Me.MenuItem11.Text = "-"
        '
        'MenuFindText
        '
        Me.MenuFindText.Index = 5
        Me.MenuFindText.Text = "Find"
        '
        'MenuItem3
        '
        Me.MenuItem3.Index = 2
        Me.MenuItem3.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItemToolbar, Me.MenuItemStatusBar, Me.MenuItem19, Me.MenuViewZoomIn, Me.MenuViewZoomOut, Me.MenuItem22, Me.MenuViewFirstPage, Me.MenuViewPreviousPage, Me.MenuViewNextPage, Me.MenuViewLastPage})
        Me.MenuItem3.Text = "View"
        '
        'MenuItemToolbar
        '
        Me.MenuItemToolbar.Checked = True
        Me.MenuItemToolbar.Index = 0
        Me.MenuItemToolbar.Text = "Toolbar"
        '
        'MenuItemStatusBar
        '
        Me.MenuItemStatusBar.Checked = True
        Me.MenuItemStatusBar.Index = 1
        Me.MenuItemStatusBar.Text = "Status Bar"
        '
        'MenuItem19
        '
        Me.MenuItem19.Index = 2
        Me.MenuItem19.Text = "-"
        '
        'MenuViewZoomIn
        '
        Me.MenuViewZoomIn.Index = 3
        Me.MenuViewZoomIn.Text = "Zoom In"
        '
        'MenuViewZoomOut
        '
        Me.MenuViewZoomOut.Index = 4
        Me.MenuViewZoomOut.Text = "Zoom Out"
        '
        'MenuItem22
        '
        Me.MenuItem22.Index = 5
        Me.MenuItem22.Text = "-"
        '
        'MenuViewFirstPage
        '
        Me.MenuViewFirstPage.Index = 6
        Me.MenuViewFirstPage.Text = "First Page"
        '
        'MenuViewPreviousPage
        '
        Me.MenuViewPreviousPage.Index = 7
        Me.MenuViewPreviousPage.Text = "Previous Page"
        '
        'MenuViewNextPage
        '
        Me.MenuViewNextPage.Index = 8
        Me.MenuViewNextPage.Text = "Next Page"
        '
        'MenuViewLastPage
        '
        Me.MenuViewLastPage.Index = 9
        Me.MenuViewLastPage.Text = "Last Page"
        '
        'MenuItem4
        '
        Me.MenuItem4.Index = 3
        Me.MenuItem4.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuSmoothImages, Me.MenuAntiAlias, Me.MenuBuiltInRasterizer})
        Me.MenuItem4.Text = "Options"
        '
        'MenuSmoothImages
        '
        Me.MenuSmoothImages.Checked = True
        Me.MenuSmoothImages.Index = 0
        Me.MenuSmoothImages.Text = "Smooth Images"
        '
        'MenuAntiAlias
        '
        Me.MenuAntiAlias.Checked = True
        Me.MenuAntiAlias.Index = 1
        Me.MenuAntiAlias.Text = "Anti-Aliased Rendering"
        '
        'MenuBuiltInRasterizer
        '
        Me.MenuBuiltInRasterizer.Checked = True
        Me.MenuBuiltInRasterizer.Index = 2
        Me.MenuBuiltInRasterizer.Text = "Built-In Rasterizer"
        '
        'MenuItem5
        '
        Me.MenuItem5.Index = 4
        Me.MenuItem5.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuWindowTileHorizontal, Me.MenuWindowTileVertical, Me.MenuWindowCascade, Me.MenuWindowCloseAll})
        Me.MenuItem5.Text = "Window"
        '
        'MenuWindowTileHorizontal
        '
        Me.MenuWindowTileHorizontal.Index = 0
        Me.MenuWindowTileHorizontal.Text = "Tile Horizontal"
        '
        'MenuWindowTileVertical
        '
        Me.MenuWindowTileVertical.Index = 1
        Me.MenuWindowTileVertical.Text = "Tile Vertical"
        '
        'MenuWindowCascade
        '
        Me.MenuWindowCascade.Index = 2
        Me.MenuWindowCascade.Text = "Cascade"
        '
        'MenuWindowCloseAll
        '
        Me.MenuWindowCloseAll.Index = 3
        Me.MenuWindowCloseAll.Text = "Close All"
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 5
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.Pan, Me.StructuralTextSelection, Me.RectangularTextSelecction, Me.RectangleZoomIn, Me.RectangleZoomOut, Me.LinAnnotation, Me.RectangleAnnotation, Me.EllipseAnnotation, Me.FreehandAnnotation, Me.ArrowAnnotation, Me.AnnotaitonEdit, Me.CustomPDFDrawTool, Me.CustomLinkCreateTool})
        Me.MenuItem1.Text = "Tools"
        '
        'Pan
        '
        Me.Pan.Index = 0
        Me.Pan.Text = "Pan"
        '
        'StructuralTextSelection
        '
        Me.StructuralTextSelection.Index = 1
        Me.StructuralTextSelection.Text = "Structural Text Selection"
        '
        'RectangularTextSelecction
        '
        Me.RectangularTextSelecction.Index = 2
        Me.RectangularTextSelecction.Text = "Rectangular Text Selection"
        '
        'RectangleZoomIn
        '
        Me.RectangleZoomIn.Index = 3
        Me.RectangleZoomIn.Text = "Rectangle Zoom-In"
        '
        'RectangleZoomOut
        '
        Me.RectangleZoomOut.Index = 4
        Me.RectangleZoomOut.Text = "Rectangle Zoom-Out"
        '
        'LinAnnotation
        '
        Me.LinAnnotation.Index = 5
        Me.LinAnnotation.Text = "Line Annotation"
        '
        'RectangleAnnotation
        '
        Me.RectangleAnnotation.Index = 6
        Me.RectangleAnnotation.Text = "Rectangle Annotation"
        '
        'EllipseAnnotation
        '
        Me.EllipseAnnotation.Index = 7
        Me.EllipseAnnotation.Text = "Ellipse Annotation"
        '
        'FreehandAnnotation
        '
        Me.FreehandAnnotation.Index = 8
        Me.FreehandAnnotation.Text = "Freehand Annotation"
        '
        'ArrowAnnotation
        '
        Me.ArrowAnnotation.Index = 9
        Me.ArrowAnnotation.Text = "Arrow Annotation"
        '
        'AnnotaitonEdit
        '
        Me.AnnotaitonEdit.Index = 10
        Me.AnnotaitonEdit.Text = "Annotation Edit"
        '
        'CustomPDFDrawTool
        '
        Me.CustomPDFDrawTool.Index = 11
        Me.CustomPDFDrawTool.Text = "Custom PDF Draw Tool"
        '
        'CustomLinkCreateTool
        '
        Me.CustomLinkCreateTool.Index = 12
        Me.CustomLinkCreateTool.Text = "Custom Link Create Tool"
        '
        'MenuItem6
        '
        Me.MenuItem6.Index = 6
        Me.MenuItem6.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuViewAbout})
        Me.MenuItem6.Text = "Help"
        '
        'MenuViewAbout
        '
        Me.MenuViewAbout.Index = 0
        Me.MenuViewAbout.Text = "About PDFView"
        '
        'StatusBar
        '
        Me.StatusBar.Location = New System.Drawing.Point(0, 682)
        Me.StatusBar.Name = "StatusBar"
        Me.StatusBar.Size = New System.Drawing.Size(840, 21)
        Me.StatusBar.TabIndex = 2
        '
        'MainForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(840, 703)
        Me.Controls.Add(Me.StatusBar)
        Me.Controls.Add(Me.ToolBar1)
        Me.Cursor = System.Windows.Forms.Cursors.Arrow
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.IsMdiContainer = True
        Me.Menu = Me.File
        Me.Name = "MainForm"
        Me.Text = "PDFView"
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region


    Private Sub OnFileOpen(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuFileOpen.Click

        Dim dlg As OpenFileDialog = New OpenFileDialog
        dlg.CheckFileExists = True
        dlg.CheckPathExists = True
        dlg.Filter = "PDF (*.pdf)|*.pdf|JPEG (*.jpg)|*.jpg|Bitmap (*.bmp)|*.bmp|PNG (*.png)|*.png|TIF (*.tif)|*.tif|All files (*.*)|*.*"
        dlg.DefaultExt = ".pdf"
        If dlg.ShowDialog = DialogResult.OK Then
            Dim view As PDFViewForm = New PDFViewForm(Me)
            If view.OpenPDF(dlg.FileName) Then
                view.Show()
            End If
        End If
    End Sub

    Public Sub UpdateButtonStates()
        Dim enabled As Boolean = False
        If Not (Me.MdiChildren Is Nothing) AndAlso Me.MdiChildren.Length > 0 Then
            enabled = True
        End If
        Me.FitPageButton.Enabled = enabled
        Me.FitWidthButton.Enabled = enabled
        Me.ZoomInButton.Enabled = enabled
        Me.ZoomOutButton.Enabled = enabled
        Me.ZoomInToolButton.Enabled = enabled
        Me.ZoomOutToolButton.Enabled = enabled
        Me.FirstPageButton.Enabled = enabled
        Me.PrevPageButton.Enabled = enabled
        Me.NextPageButton.Enabled = enabled
        Me.LastPageButton.Enabled = enabled
        Me.PageSingleButton.Enabled = enabled
        Me.PageSingleContButton.Enabled = enabled
        Me.PageFacingContButton.Enabled = enabled
        Me.PageFacingButton.Enabled = enabled
        Me.RotateClockwise.Enabled = enabled
        Me.RotateCounterClockwise.Enabled = enabled
    End Sub

    Private Sub ToolBar1_ButtonClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ToolBarButtonClickEventArgs) Handles ToolBar1.ButtonClick

        Dim tool_mode As MyPDFView.CustomToolMode = MyPDFView.CustomToolMode.e_none

        'If the user clicked a tool set only the clicked
        'button (of the tools) to be pushed
        'and change the tool mode based on the button pushed
        If ((e.Button Is HandToolButton) OrElse (e.Button Is ZoomInToolButton) OrElse (e.Button Is ZoomInToolButton) OrElse (e.Button Is ZoomOutToolButton) OrElse (e.Button Is PencilToolButton) OrElse (e.Button Is LinkCreateToolButton) OrElse (e.Button Is TextSelectButton) OrElse (e.Button Is RectTextSelectButton)) Then
            If e.Button Is HandToolButton Then
                HandToolButton.Pushed = True
                PencilToolButton.Pushed = False
                ZoomInToolButton.Pushed = False
                ZoomOutToolButton.Pushed = False
                LinkCreateToolButton.Pushed = False
                TextSelectButton.Pushed = False
                RectTextSelectButton.Pushed = False
                SetToolMode(PDFViewCtrl.ToolMode.e_pan, MyPDFView.CustomToolMode.e_none)
            ElseIf e.Button Is ZoomInToolButton Then
                HandToolButton.Pushed = False
                PencilToolButton.Pushed = False
                ZoomInToolButton.Pushed = True
                ZoomOutToolButton.Pushed = False
                LinkCreateToolButton.Pushed = False
                TextSelectButton.Pushed = False
                RectTextSelectButton.Pushed = False
                SetToolMode(PDFViewCtrl.ToolMode.e_zoom_in, MyPDFView.CustomToolMode.e_none)
            ElseIf e.Button Is ZoomOutToolButton Then
                HandToolButton.Pushed = False
                PencilToolButton.Pushed = False
                ZoomInToolButton.Pushed = False
                ZoomOutToolButton.Pushed = True
                LinkCreateToolButton.Pushed = False
                TextSelectButton.Pushed = False
                RectTextSelectButton.Pushed = False
                SetToolMode(PDFViewCtrl.ToolMode.e_zoom_out, MyPDFView.CustomToolMode.e_none)
            ElseIf e.Button Is PencilToolButton Then
                HandToolButton.Pushed = False
                PencilToolButton.Pushed = True
                ZoomInToolButton.Pushed = False
                ZoomOutToolButton.Pushed = False
                LinkCreateToolButton.Pushed = False
                TextSelectButton.Pushed = False
                RectTextSelectButton.Pushed = False
                SetToolMode(PDFViewCtrl.ToolMode.e_custom, MyPDFView.CustomToolMode.e_custom_draw)
            ElseIf e.Button Is LinkCreateToolButton Then
                HandToolButton.Pushed = False
                PencilToolButton.Pushed = False
                ZoomInToolButton.Pushed = False
                ZoomOutToolButton.Pushed = False
                LinkCreateToolButton.Pushed = True
                TextSelectButton.Pushed = False
                RectTextSelectButton.Pushed = False
                SetToolMode(PDFViewCtrl.ToolMode.e_custom, MyPDFView.CustomToolMode.e_custom_link_create)
            ElseIf e.Button Is TextSelectButton Then
                HandToolButton.Pushed = False
                PencilToolButton.Pushed = False
                ZoomInToolButton.Pushed = False
                ZoomOutToolButton.Pushed = False
                LinkCreateToolButton.Pushed = False
                TextSelectButton.Pushed = True
                RectTextSelectButton.Pushed = False
                SetToolMode(PDFViewCtrl.ToolMode.e_text_struct_select, MyPDFView.CustomToolMode.e_none)
            ElseIf e.Button Is RectTextSelectButton Then
                HandToolButton.Pushed = False
                PencilToolButton.Pushed = False
                ZoomInToolButton.Pushed = False
                ZoomOutToolButton.Pushed = False
                LinkCreateToolButton.Pushed = False
                TextSelectButton.Pushed = False
                RectTextSelectButton.Pushed = True
                SetToolMode(PDFViewCtrl.ToolMode.e_text_rect_select, MyPDFView.CustomToolMode.e_none)
            End If
        End If

        'handle the actions for other buttons
        If e.Button Is FileOpenButton Then
            OnFileOpen(Nothing, Nothing)
        ElseIf e.Button Is SaveAsButton Then
            Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
            If Not (pdf_view Is Nothing) Then
                pdf_view.SaveAs()
            End If
        ElseIf e.Button Is PrintButton Then
            Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
            If Not (pdf_view Is Nothing) Then
                pdf_view.Print()
            End If
        ElseIf e.Button Is FitPageButton Then
            Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
            If Not (pdf_view Is Nothing) Then
                pdf_view.FitPage()
            End If
        ElseIf e.Button Is FitWidthButton Then
            Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
            If Not (pdf_view Is Nothing) Then
                pdf_view.FitWidth()
            End If
        ElseIf e.Button Is ZoomInButton Then
            OnZoomIn(sender, e)
        ElseIf e.Button Is ZoomOutButton Then
            OnZoomOut(sender, e)
        ElseIf e.Button Is FirstPageButton Then
            OnFirstPage(sender, e)
        ElseIf e.Button Is PrevPageButton Then
            OnPrevPage(sender, e)
        ElseIf e.Button Is NextPageButton Then
            OnNextPage(sender, e)
        ElseIf e.Button Is LastPageButton Then
            OnLastPage(sender, e)
        ElseIf e.Button Is PageSingleButton Then
            Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
            If Not (pdf_view Is Nothing) Then
                pdf_view.PageSingle()
            End If
        ElseIf e.Button Is PageSingleContButton Then
            Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
            If Not (pdf_view Is Nothing) Then
                pdf_view.PageSingleContinuous()
            End If
        ElseIf e.Button Is PageFacingContButton Then
            Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
            If Not (pdf_view Is Nothing) Then
                pdf_view.PageFacingContinuous()
            End If
        ElseIf e.Button Is PageFacingButton Then
            Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
            If Not (pdf_view Is Nothing) Then
                pdf_view.PageFacing()
            End If
        ElseIf e.Button Is RotateClockwise Then
            Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
            If Not (pdf_view Is Nothing) Then
                pdf_view.RotateClockwise()
            End If
        ElseIf e.Button Is RotateCounterClockwise Then
            Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
            If Not (pdf_view Is Nothing) Then
                pdf_view.RotateCounterClockwise()
            End If
        End If
    End Sub

    Private Sub SetToolMode(ByVal tool_mode As PDFViewCtrl.ToolMode, ByVal custom_tool_mode As MyPDFView.CustomToolMode)

        Dim children() As Form = MdiChildren
        If Not (children Is Nothing) Then
            Dim i As Integer
            For i = 0 To (children.Length - 1)
                Dim pdf_view As PDFViewForm = CType(children(i), PDFViewForm)
                If Not (pdf_view Is Nothing) Then
                    pdf_view.SetToolMode(tool_mode, custom_tool_mode)
                End If
            Next i
        End If
    End Sub

    Private Sub OnZoomIn(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuViewZoomIn.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not (pdf_view Is Nothing) Then
            pdf_view.ZoomIn()
        End If
    End Sub

    Private Sub OnZoomOut(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuViewZoomOut.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not (pdf_view Is Nothing) Then
            pdf_view.ZoomOut()
        End If
    End Sub

    Private Sub OnFirstPage(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuViewFirstPage.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not (pdf_view Is Nothing) Then
            pdf_view.FirstPage()
        End If
    End Sub

    Private Sub OnPrevPage(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuViewPreviousPage.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not (pdf_view Is Nothing) Then
            pdf_view.PrevPage()
        End If
    End Sub

    Private Sub OnNextPage(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuViewNextPage.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not (pdf_view Is Nothing) Then
            pdf_view.NextPage()
        End If
    End Sub

    Private Sub OnLastPage(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuViewLastPage.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not (pdf_view Is Nothing) Then
            pdf_view.LastPage()
        End If
    End Sub

    Private Sub OnAboutPDFView(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuViewAbout.Click
        MessageBox.Show("PDFView Sample Application Version 1.0", "About PDFView")
    End Sub

    Private Sub OnAppExit(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuExit.Click
        Application.Exit()
    End Sub

    Private Sub OnSmoothImages(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuSmoothImages.Click
        smooth_images = Not smooth_images
        Me.MenuSmoothImages.Checked = smooth_images
        Dim children As Form() = Me.MdiChildren
        If Not (children Is Nothing) Then
            Dim i As Integer = 0
            While i < children.Length
                Dim pdf_view As PDFViewForm = CType(children(i), PDFViewForm)
                If Not (pdf_view Is Nothing) Then
                    pdf_view.SetSmoothImages(smooth_images)
                End If
                i = i + 1
            End While
        End If
    End Sub

    Private Sub OnAntiAlias(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAntiAlias.Click
        anti_alias = Not anti_alias
        Me.MenuAntiAlias.Checked = anti_alias
        Dim children As Form() = Me.MdiChildren
        If Not (children Is Nothing) Then
            Dim i As Integer = 0
            While i < children.Length
                Dim pdf_view As PDFViewForm = CType(children(i), PDFViewForm)
                If Not (pdf_view Is Nothing) Then
                    pdf_view.SetAntiAliasing(anti_alias)
                End If
                i = i + 1
            End While
        End If
    End Sub

    Private Sub OnRasterizerToggle(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuBuiltInRasterizer.Click
        builtin_rasterizer = Not builtin_rasterizer
        Me.MenuBuiltInRasterizer.Checked = builtin_rasterizer
        Dim children As Form() = Me.MdiChildren
        If Not (children Is Nothing) Then
            Dim i As Integer = 0
            While i < children.Length
                Dim pdf_view As PDFViewForm = CType(children(i), PDFViewForm)
                If Not (pdf_view Is Nothing) Then
                    pdf_view.SetRasterizer(builtin_rasterizer)
                End If
                i = i + 1
            End While
        End If
    End Sub


    Private Sub OnFileClose(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuFileClose.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not (pdf_view Is Nothing) Then
            pdf_view.Close()
        End If
    End Sub

    Private Sub OnFileCloseAll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuFileCloseAll.Click, MenuWindowCloseAll.Click

        Dim children As Form() = Me.MdiChildren
        If Not (children Is Nothing) Then
            Dim i As Integer = 0
            While i < children.Length
                Dim pdf_view As PDFViewForm = CType(children(i), PDFViewForm)
                If Not (pdf_view Is Nothing) Then
                    pdf_view.Close()
                End If
                i = i + 1
            End While
        End If
    End Sub

    Public Sub UpdateStatusBar(ByVal current_page As Integer, ByVal num_pages As Integer)
        If _current_page > 0 Then
            Dim txt As String = String.Format("Page {0} of {1}.", current_page, num_pages)
            StatusBar.Text = txt
        End If
    End Sub


    Private Sub OnWindowCascade(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuWindowCascade.Click
        Me.LayoutMdi(MdiLayout.Cascade)
    End Sub

    Private Sub OnWindowTile(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuWindowTileHorizontal.Click
        Me.LayoutMdi(MdiLayout.TileHorizontal)
    End Sub

    Private Sub OnWindowTileVertical(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuWindowTileVertical.Click
        Me.LayoutMdi(MdiLayout.TileVertical)
    End Sub

    Private Sub MenuFileSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuFileSaveAs.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not (pdf_view Is Nothing) Then
            pdf_view.SaveAs()
        End If
    End Sub

    Private Sub MenuItemToolbar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemToolbar.Click
        ToolBar1.Visible = Not ToolBar1.Visible
        MenuItemToolbar.Checked = Not MenuItemToolbar.Checked
    End Sub

    Private Sub MenuItemStatusBar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItemStatusBar.Click
        StatusBar.Visible = Not StatusBar.Visible
        MenuItemStatusBar.Checked = Not MenuItemStatusBar.Checked
    End Sub

    Private Sub MenuFileSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuFileSave.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not (pdf_view Is Nothing) Then
            pdf_view.Save(pdf_view.Text)
        End If
    End Sub

    Private Sub MenuFileExport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuFileExport.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not (pdf_view Is Nothing) Then
            pdf_view.Export()
        End If
    End Sub

    Private Sub MenuPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuPrint.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not (pdf_view Is Nothing) Then
            pdf_view.Print()
        End If
    End Sub


    Private Sub CopyText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuCopyText.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not pdf_view Is Nothing Then
            pdf_view.CopySelectedText()
        End If
    End Sub

    Private Sub CopyTextAsHTML_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuCopyTextAsHTML.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not pdf_view Is Nothing Then
            pdf_view.CopySelectedText()
        End If
    End Sub

    Private Sub SelectAllText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuSelectAll.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not pdf_view Is Nothing Then
            pdf_view.SelectAll()
        End If
    End Sub

    Private Sub DeselectAllText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuDeselect.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not pdf_view Is Nothing Then
            pdf_view.DeselectAll()
        End If
    End Sub

    Private Sub FindText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuFindText.Click
        Dim pdf_view As PDFViewForm = CType(Me.ActiveMdiChild, PDFViewForm)
        If Not pdf_view Is Nothing Then
            pdf_view.FindText()
        End If
    End Sub


    Private Sub Pan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Pan.Click
        SetToolMode(PDFViewCtrl.ToolMode.e_pan, MyPDFView.CustomToolMode.e_none)
    End Sub

    Private Sub StructuralTextSelection_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StructuralTextSelection.Click
        SetToolMode(PDFViewCtrl.ToolMode.e_text_struct_select, MyPDFView.CustomToolMode.e_none)
    End Sub

    Private Sub RectangularTextSelecction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RectangularTextSelecction.Click
        SetToolMode(PDFViewCtrl.ToolMode.e_text_rect_select, MyPDFView.CustomToolMode.e_none)
    End Sub

    Private Sub RectangleZoomIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RectangleZoomIn.Click
        SetToolMode(PDFViewCtrl.ToolMode.e_zoom_in, MyPDFView.CustomToolMode.e_none)
    End Sub

    Private Sub RectangleZoomOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RectangleZoomOut.Click
        SetToolMode(PDFViewCtrl.ToolMode.e_zoom_out, MyPDFView.CustomToolMode.e_none)
    End Sub

    Private Sub LinAnnotation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LinAnnotation.Click
        SetToolMode(PDFViewCtrl.ToolMode.e_line_create, MyPDFView.CustomToolMode.e_none)
    End Sub

    Private Sub RectangleAnnotation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RectangleAnnotation.Click
        SetToolMode(PDFViewCtrl.ToolMode.e_rect_create, MyPDFView.CustomToolMode.e_none)
    End Sub

    Private Sub EllipseAnnotation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EllipseAnnotation.Click
        SetToolMode(PDFViewCtrl.ToolMode.e_oval_create, MyPDFView.CustomToolMode.e_none)
    End Sub

    Private Sub FreehandAnnotation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FreehandAnnotation.Click
        SetToolMode(PDFViewCtrl.ToolMode.e_ink_create, MyPDFView.CustomToolMode.e_none)
    End Sub

    Private Sub ArrowAnnotation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ArrowAnnotation.Click
        SetToolMode(PDFViewCtrl.ToolMode.e_arrow_create, MyPDFView.CustomToolMode.e_none)
    End Sub

    Private Sub AnnotaitonEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AnnotaitonEdit.Click
        SetToolMode(PDFViewCtrl.ToolMode.e_annot_edit, MyPDFView.CustomToolMode.e_none)
    End Sub

    Private Sub CustomPDFDrawTool_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CustomPDFDrawTool.Click
        SetToolMode(PDFViewCtrl.ToolMode.e_custom, MyPDFView.CustomToolMode.e_custom_draw)
    End Sub

    Private Sub CustomLinkCreateTool_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CustomLinkCreateTool.Click
        SetToolMode(PDFViewCtrl.ToolMode.e_custom, MyPDFView.CustomToolMode.e_custom_link_create)
    End Sub
End Class
